#include <stdio.h>
#include <stdlib.h>
///demonstrates allocation of a bidimensional matrix of ints
int main()
{
    /// array is of type pointer to pointer to int
    int **array;
    /// allocate an array of 5 pointers to int
    /// there will be 5 rows
    array = (int **)malloc(5 * sizeof(int *));
    /// allocate an array of 20 ints
    /// can have 4 columns (there are 5 rows)
    *array = (int *)malloc(20 * sizeof(int));
    /// init rows and fill the array with values
    for (int i = 0; i < 5; i++)
    {
        /// array[i] has address of row start
        array[i] = array[0] + 4 * i;
        /// fill values
        for (int j = 0; j < 4; j++)
        {
            array[i][j] = 10 * i + j;
            printf("%02d ", array[i][j]);
        }
        puts("");
    }
    printf("a: %d\n", array[2][1]);
    printf("b: %d\n", *(array[4]));
    printf("c: %d\n", array[0][7]);
    printf("d: %d\n", *(array[2]) + *(array[1]));
    return 0;
}

