#include <stdio.h>
#include <stdlib.h>
#include "trace.h"
// example function
int foo(int a, int b)
{
    // trace at entry
    trace("%s: a=%d b=%d\n", __func__, a, b);
    int c = a + b;
    // trace before exit
    trace("%s: c=%d\n", __func__, c);
    return c;
}
int main()
{
    int a[5] = {7, 2, 1, 4};
    stopTrace();
    printf("Trace test!\n");
    // prints name of file, current function, and line number
    trace("File: %s, %s, line: %d\n", __FILE__, __func__, __LINE__);
    trace("%s: a[3]=%d a[0]=%d\n", __func__, a[3], a[0]);
    printf("foo(%d, %d)=%d", a[1], a[3], foo(a[1], a[3]));
    stopTrace();
    return 0;
}
